-- #######################################
-- #######################################
--       GOH DEATH KNIGHT EVENT LOG
-- #######################################
-- #######################################

function GoH_DeathKnight.events.PLAYER_ENTERING_WORLD()

	-- print("Hello World.");
	GoH5_DeathKnight_SavedVariables();
	GoH_Settings_Set_Menu_Button_Images();
	GoH_DeathKnight_Set_Menu_Button_Images();
	doSavedVariable_Plugin_Check();
	Show_Intro_Frame();

	-- GOH SETTING: RESET LAST KILL BY YOU
	GoHv5_DeathKnight_Data.config.Last_Kill_By_You = "NO";
	GoHv5_DeathKnight_Data.config.Has_Taken_Damage = "NO";
	GoHv5_DeathKnight_Data.config.Flawless_Victory = "NO";

end

function GoH_DeathKnight.events.ADDON_ACTION_BLOCKED(arg1,arg2,arg3,arg4)

	-- ################################################################

	-- DEBUGGER
	if GoHv5_DeathKnight_Data.config.DEBUG_ADDON_ACTION_BLOCKED == "YES" then
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~~~~~~~~~~~ BEGIN DEBUG ~~~~~~~~~~~");
			print("~    (ADDON_ACTION_BLOCKED)    ~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
			if arg1 ~= nil then print("arg1: "..arg1) end;
			if arg2 ~= nil then print("arg2: "..arg2) end;
			if arg3 ~= nil then print("arg3: "..arg3) end;
			if arg4 ~= nil then print("arg4: "..arg4) end;
			print("");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~~~~~~~~~~~~ END DEBUG ~~~~~~~~~~~~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
	end

	-- ################################################################

end

function GoH_DeathKnight.events.TOO_MANY_LUA_ERRORS(arg1,arg2,arg3,arg4)

	-- ################################################################

	-- DEBUGGER
	if (GoHv5_DeathKnight_Data.config.DEBUG_ADDON_ACTION_BLOCKED == "YES") or (GoHv5_DeathKnight_Data.config.DEBUG_ADDON_ACTION_FORBIDDEN == "YES") then
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~~~~~~~~~~~ BEGIN DEBUG ~~~~~~~~~~~");
			print("~        (UI_ERROR_MESSAGE)        ~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
			if arg1 ~= nil then print("arg1: "..arg1) end;
			if arg2 ~= nil then print("arg2: "..arg2) end;
			if arg3 ~= nil then print("arg3: "..arg3) end;
			if arg4 ~= nil then print("arg4: "..arg4) end;
			print("");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~~~~~~~~~~~~ END DEBUG ~~~~~~~~~~~~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
	end

	-- ################################################################

		-- TIRED OF THE BLIZZARD BULLSHIT. WE CAN USE PROPER .LUA ERROR REPORTERS.
	if GoHv5_DeathKnight_Data.config.DEBUG_HIDE_BLIZZARD_LUA_ERRORS == "YES" then
		HideUIPanel(StaticPopup1);
		ScriptErrorsFrame:Hide();
	end
end

function GoH_DeathKnight.events.ADDON_ACTION_FORBIDDEN(arg1,arg2)

	-- ################################################################

	-- DEBUGGER
	if GoHv5_DeathKnight_Data.config.DEBUG_ADDON_ACTION_FORBIDDEN == "YES" then
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~~~~~~~~~~~ BEGIN DEBUG ~~~~~~~~~~~");
			print("~   (ADDON_ACTION_FORBIDDEN)   ~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
			if arg1 ~= nil then print("arg1: "..arg1) end;
			if arg2 ~= nil then print("arg2: "..arg2) end;
			print("");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~ DOESN'T TELL ME FUCK ALL BLIZZARD! ~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~~~~~~~~~~~~ END DEBUG ~~~~~~~~~~~~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
	end

	-- FUCKING STUPID BLIZZARD SHIT.
	if (GoHv5_DeathKnight_Data.config.DEBUG_HIDE_BLIZZARD_ACTION_FORBIDDEN == "YES") then
		HideUIPanel(StaticPopup1);
	end

	-- ################################################################

end

function GoH_DeathKnight.events.COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2, ...)

  -- ###########################################################################################################
  -- SINCE THESE ARE LOCAL, YOU CAN RE-USE THE SAME NAMES IN OTHER GOH CLASS MODS AND DON'T HAVE TO CHANGE THEM.
  -- ###########################################################################################################
  local GoH_spellID, GoH_spellName, GoH_all_spellSchool, GoH_amount, GoH_overkill, GoH_school, GoH_resisted, GoH_blocked, GoH_absorbed, GoH_critical = ...

	-- CHECK THE TIMER
	if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == nil then
		GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "YES";
	end

	-- ################################################################
	-- ################################################################

	-- DEBUGGER
	if GoHv5_DeathKnight_Data.config.DEBUG_COMBAT_LOG_EVENT_UNFILTERED == "YES" then
		if (sourceName == GoH_DeathKnight.CharName) then
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~~~~~~~~~~~ BEGIN DEBUG ~~~~~~~~~~~");
			print("~ (COMBAT_LOG_EVENT_UNFILTERED) ~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
			if timestamp ~= nil then print("timestamp: "..timestamp) end;
			if event ~= nil then print("event: "..event) end;
			if sourceGUID ~= nil then print("sourceGUID: "..sourceGUID) end;
			if sourceName ~= nil then print("sourceName: "..sourceName) end;
			if sourceFlags ~= nil then print("sourceFlags: "..sourceFlags) end;
			if sourceFlags2 ~= nil then print("sourceFlags2: "..sourceFlags2) end;
			if destGUID ~= nil then print("destGUID: "..destGUID) end;
			if destName ~= nil then print("destName: "..destName) end;
			if destFlags ~= nil then print("destFlags: "..destFlags) end;
			if destFlags2 ~= nil then print("destFlags2: "..destFlags2) end;
			print("");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
			if GoH_spellID ~= nil then print("GoH_spellID: "..GoH_spellID) end;
			if GoH_spellName ~= nil then print("GoH_spellName: "..GoH_spellName) end;
			if GoH_all_spellSchool ~= nil then print("GoH_all_spellSchool: "..GoH_all_spellSchool) end;
			if GoH_amount ~= nil then print("GoH_amount: "..GoH_amount) end;
			if GoH_overkill ~= nil then print("GoH_overkill: "..GoH_overkill) end;
			if GoH_school ~= nil then print("GoH_school: "..GoH_school) end;
			if GoH_resisted ~= nil then print("GoH_resisted: "..GoH_resisted) end;
			if GoH_blocked ~= nil then print("GoH_blocked: "..GoH_blocked) end;
			if GoH_absorbed ~= nil then print("GoH_absorbed: "..GoH_absorbed) end;
			if GoH_critical ~= nil then print("GoH_critical: "..GoH_critical) end;
			print("");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~~~~~~~~~~~~ END DEBUG ~~~~~~~~~~~~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
		end
	end

	-- ################################################################
	-- ################################################################

	if (UnitHealth("player") / UnitHealthMax("player") ~= 1) then
		-- IF YOUR HEALTH IS NOT FULL THEN YOU HAVE TAKEN DAMAGE AT SOME POINT
		GoHv5_DeathKnight_Data.config.Has_Taken_Damage = "YES";
		GoHv5_DeathKnight_Data.config.Flawless_Victory = "NO";
	end

	-- ################################################################
	-- ################################################################

-- ENVIRONMENT DAMAGE LAUGH AND INSULTS
if GoHv5_DeathKnight_Data.config.Play_Insults == "YES" then
	if (event == "ENVIRONMENTAL_DAMAGE") and (destName == GoH_DeathKnight.CharName) and (UnitHealth("player") / UnitHealthMax("player") <= 0.1) and (UnitHealth("player") > 1) then
		if (GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted == "NO") then
			Play_Env_Dont_Make_Me_Laugh();
			GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted = "YES";
		end
	end

	if (UnitHealth("player") / UnitHealthMax("player") <= 0.1) and (UnitHealth("player") > 1) then
		if (GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted == "NO") then
			Play_Combat_Insult_Random_Sound();
			GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted = "YES";
		end
	end

	if (UnitHealth("player") / UnitHealthMax("player") == 1) then
		-- YOU ARE BACK TO FULL HEALTH SO RESET INSULTER
		GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted = "NO";
	end
end

	-- ################################################################
	-- ################################################################
	-- ################################################################
	-- ################################################################

-- HEALTH HEALME EMOTE
if GoHv5_DeathKnight_Data.config.Use_Health_Warning == "YES" then
	if GoHv5_DeathKnight_Data.config.Use_Health_Warning_Emote == "YES"  then
		if GoHv5_DeathKnight_Data.config.Use_Health_Warning_Emote_Shown == "NO" then
			if ((UnitHealth("player") / UnitHealthMax("player")) <= (GoHv5_DeathKnight_Data.config.Health_Percentage)) then
			   DoEmote("healme");
			   GoHv5_DeathKnight_Data.config.Use_Health_Warning_Emote_Shown = "YES";
			end
		end
		if ((UnitHealth("player") / UnitHealthMax("player")) >= (GoHv5_DeathKnight_Data.config.Health_Percentage+0.05)) then
		   GoHv5_DeathKnight_Data.config.Use_Health_Warning_Emote_Shown = "NO";
		end
	end
end

-- MANA OOM EMOTE
if GoHv5_DeathKnight_Data.config.Use_Mana_Warning == "YES" then
	if GoHv5_DeathKnight_Data.config.Use_Mana_Warning_Emote == "YES"  then
		if GoHv5_DeathKnight_Data.config.Use_Mana_Warning_Emote_Shown == "NO" then
			if ((UnitMana("player") / UnitManaMax("player")) <= (GoHv5_DeathKnight_Data.config.Mana_Percentage)) then
			   DoEmote("oom");
			   GoHv5_DeathKnight_Data.config.Use_Mana_Warning_Emote_Shown = "YES";
			end
		end
		if ((UnitMana("player") / UnitManaMax("player")) >= (GoHv5_DeathKnight_Data.config.Mana_Percentage+0.05)) then
		   GoHv5_DeathKnight_Data.config.Use_Mana_Warning_Emote_Shown = "NO";
		end
	end
end

	-- ################################################################
	-- ################################################################
	-- ################################################################
	-- ################################################################
	-- ################################################################
	-- ################################################################
	-- ################################################################
	-- BEGIN DEATHKNIGHT SPELLS
	-- ################################################################

	if (GoH_DeathKnight.Class == "DEATHKNIGHT") then -- BEGIN CLASS CHECK

		-- DEATH KNIGHT: DEATH GRIP
		if GoHv5_DeathKnight_Data.config.Death_Grip == "YES" then
			if (GoH_spellID == 49576) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					GoHv5_DeathKnight_Data.config.Spell_Was_Cast = "YES";
					Play_Random_DEATHGRIP_Sound();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: HORN OF WINTER
		if GoHv5_DeathKnight_Data.config.Horn_of_Winter == "YES" then
			if (GoH_spellID == 57330) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				-- HORN OF WINTER HAS BEEN CASTED
				GoHv5_DeathKnight_Data.config.Horn_of_Winter_Casted = "YES";

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\HornOfWinter_Begins_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: DEATH AND DECAY
		if GoHv5_DeathKnight_Data.config.Death_and_Decay == "YES" then
			if (GoH_spellID == 43265) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\StealthDetected_Sonar.mp3","Master");

					-- CALL RANDOM EASTER EGG
					Call_RANDOM_Toasty_Frame();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: PESTILENCE
		if GoHv5_DeathKnight_Data.config.Pestilence == "YES" then
			if (GoH_spellID == 50842) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\I_See_You_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: OUTBREAK
		if GoHv5_DeathKnight_Data.config.Outbreak == "YES" then
			if (GoH_spellID == 77575) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Thats_Enough_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: BLOOD TAP
		if GoHv5_DeathKnight_Data.config.Blood_Tap == "YES" then
			if (GoH_spellID == 45529) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
				-- YOU WILL DIE
				if (GoH_DeathKnight.Gender == "Female") then
					PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Female_WoW_Sounds\\You_Will_Die_Female.mp3","Master");
				else
	    			PlaySoundFile("Sound\\Creature\\CThun\\CThunYouWillDie.Wav","Master");
				end

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: DEATH COIL
		if GoHv5_DeathKnight_Data.config.Death_Coil == "YES" then
			if (GoH_spellID == 47541) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Death_Coil.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: EMPOWER RUNE WEAPON
		if GoHv5_DeathKnight_Data.config.Empower_Rune_Weapon == "YES" then
			if (GoH_spellID == 47568) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					-- FORSTMORN HUNGERS
					if (GoH_DeathKnight.Gender == "Female") then
						PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Female_WoW_Sounds\\Frostmourn_Hungers_Female.mp3","Master");
					else
						PlaySoundFile("Sound\\Creature\\LichKing\\IC_Lich King_FMAttack01.wav","Master");
					end

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: ICEBOUND FORTITUDE
		if GoHv5_DeathKnight_Data.config.Icebound_Fortitude == "YES" then
			if (GoH_spellID == 48792) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\IceboundFortitude_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: BLOOD PRESENCE
		if GoHv5_DeathKnight_Data.config.Blood_Presence == "YES" then
			if (GoH_spellID == 48263) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Blood_Craze_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: FROST PRESENCE
		if GoHv5_DeathKnight_Data.config.Frost_Presence == "YES" then
			if (GoH_spellID == 48266) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\FreezingFog_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: UNHOLY PRESENCE
		if GoHv5_DeathKnight_Data.config.Unholy_Presence == "YES" then
			if (GoH_spellID == 48265) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\HolyPower_1.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: ANTI-MAGIC SHELL
		if GoHv5_DeathKnight_Data.config.AntiMagic_Shell == "YES" then
			if (GoH_spellID == 48707) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Camouflage.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			 -- DEATH KNIGHT: ANTI-MAGIC ZONE
		if GoHv5_DeathKnight_Data.config.AntiMagic_Zone == "YES" then
			if (GoH_spellID == 51052) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Get_Under_Here_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		-- DEATH KNIGHT: RAISE ALLY
		if GoHv5_DeathKnight_Data.config.Raise_Ally == "YES" then
			if (((GoH_spellName == DeathKnight_Void_Touched_Name) or (GoH_spellID == 97821) or (GoH_spellName == DeathKnight_Raise_Ally_Name) or (GoH_spellID == 61999)) and ((event == "SPELL_CAST_SUCCESS") or (event == "SPELL_AURA_APPLIED")) and (sourceName == GoH_DeathKnight.CharName)) then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\RaiseAlly_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		-- DEATH KNIGHT: (RAISE ALLY) VOID TOUCH DEBUFF
		if GoHv5_DeathKnight_Data.config.Void_Touch_Debuff == "YES" then
			if (GoH_spellID == 97821) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\RaiseAlly_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: RAISE DEAD
		if GoHv5_DeathKnight_Data.config.Raise_Dead == "YES" then
			if (GoH_spellName == DeathKnight_Raise_Dead_Name) and (event == "SPELL_SUMMON") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\RaiseDead_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: ARMY OF THE DEAD
		if GoHv5_DeathKnight_Data.config.Army_of_the_Dead == "YES" then
			if (GoH_spellID == 42650) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\ArmyoftheDead2_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: SUMMON GARGOYLE
		if GoHv5_DeathKnight_Data.config.Summon_Gargoyle == "YES" then
			if (GoH_spellID == 49206) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\SummonGargoyle_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: DEATH PACT
		if GoHv5_DeathKnight_Data.config.Death_Pact == "YES" then
			if (GoH_spellID == 48743) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Death_Pact_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: DARK TRANSFORMATION
		if GoHv5_DeathKnight_Data.config.Dark_Transformation == "YES" then
			if (GoH_spellID == 63560) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Dark_Transformation_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: STRANGULATE
		if GoHv5_DeathKnight_Data.config.Strangulate == "YES" then
			if (GoH_spellID == 47476) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then


					-- PLAY YOUR SOUND
					-- YOU ARE NOT PREPARED
					if (GoH_DeathKnight.Gender == "Female") then
						PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Female_WoW_Sounds\\You_Are_Not_Prepared_Female.mp3","Master");
					else
						PlaySoundFile("Sound\\Creature\\Illidan\\BLACK_Illidan_04.wav","Master");
					end

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: MIND FREEZE
		if GoHv5_DeathKnight_Data.config.Mind_Freeze == "YES" then
			if (GoH_spellID == 47528) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					-- YOU ARE NOT PREPARED
					if (GoH_DeathKnight.Gender == "Female") then
						PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Female_WoW_Sounds\\You_Are_Not_Prepared_Female.mp3","Master");
					else
						PlaySoundFile("Sound\\Creature\\Illidan\\BLACK_Illidan_04.wav","Master");
					end

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: UNHOLY FRENZY
		if GoHv5_DeathKnight_Data.config.Unholy_Frenzy == "YES" then
			if (GoH_spellID == 49016) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Slaughter_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: BLOOD BOIL
		if GoHv5_DeathKnight_Data.config.Blood_Boil == "YES" then
			if (GoH_spellID == 48721) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Toasty_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			 -- DEATH KNIGHT: DARK COMMAND
		if GoHv5_DeathKnight_Data.config.Dark_Command == "YES" then
			if (GoH_spellID == 56222) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					GoHv5_DeathKnight_Data.config.Spell_Was_Cast = "YES";
					Play_Random_DEATHGRIP_Sound();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			 -- DEATH KNIGHT: BONE SHIELD
		if GoHv5_DeathKnight_Data.config.Bone_Shield == "YES" then
			if (GoH_spellID == 49222) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\BoneShield_Begins_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: UNHOLY BLIGHT
		if GoHv5_DeathKnight_Data.config.Unholy_Blight == "YES" then
			if (GoH_spellID == 115989) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\ArmyoftheDead_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: CHAINS OF ICE
		if GoHv5_DeathKnight_Data.config.Chains_of_Ice == "YES" then
			if (GoH_spellID == 45524) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: DARK SIMULATION
		if GoHv5_DeathKnight_Data.config.Dark_Simulation == "YES" then
			if (GoH_spellID == 77606) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\All_Too_Easy_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: ICY TOUCH
		if GoHv5_DeathKnight_Data.config.Icy_Touch == "YES" then
			if (GoH_spellID == 45477) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Critical_1.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: PATH OF FROST
		if GoHv5_DeathKnight_Data.config.Path_of_Frost == "YES" then
			if (GoH_spellID == 3714) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Death_Coil_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: DANCING RUNE WEAPON
		if GoHv5_DeathKnight_Data.config.Dancing_Rune_Weapon == "YES" then
			if (GoH_spellID == 49028) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: REMORSELESS WINTER
		if GoHv5_DeathKnight_Data.config.Remorseless_Winter == "YES" then
			if (GoH_spellID == 108200) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\FreezingFog_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: ASPHYXIATE
		if GoHv5_DeathKnight_Data.config.Asphyxiate == "YES" then
			if (GoH_spellID == 108194) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Cower_Before_Me_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: DEATHS ADVANCE
		if GoHv5_DeathKnight_Data.config.Deaths_Advance == "YES" then
			if (GoH_spellID == 96268) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					-- YOU ARE NOT PREPARED
					if (GoH_DeathKnight.Gender == "Female") then
						PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Female_WoW_Sounds\\You_Are_Not_Prepared_Female.mp3","Master");
					else
						PlaySoundFile("Sound\\Creature\\Illidan\\BLACK_Illidan_04.wav","Master");
					end

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: GORFIENDS GRASP
		if GoHv5_DeathKnight_Data.config.Gorfiends_Grasp == "YES" then
			if (GoH_spellID == 108199) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					GoHv5_DeathKnight_Data.config.Spell_Was_Cast = "YES";
					Play_Random_DEATHGRIP_Sound();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		-- DEATH KNIGHT: DEATH GATE
		if GoHv5_DeathKnight_Data.config.Death_Gate == "YES" then
			if (GoH_spellName == DeathKnight_Death_Gate_Name) and (event == "SPELL_CAST_START") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: BLOOD STRIKE
		if GoHv5_DeathKnight_Data.config.Blood_Strike == "YES" then
			if (GoH_spellName == DeathKnight_Blood_Strike_Name) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Blood_Strike_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: FROST STRIKE
		if GoHv5_DeathKnight_Data.config.Frost_Strike == "YES" then
			if (GoH_spellName == DeathKnight_Frost_Strike_Name) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Frost_Strike_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: HEART STRIKE
		if GoHv5_DeathKnight_Data.config.Heart_Strike == "YES" then
			if (GoH_spellName == DeathKnight_Heart_Strike_Name) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Heart_Strike_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: CONTROL DEAD
		if GoHv5_DeathKnight_Data.config.Control_Undead == "YES" then
			if (GoH_spellName == DeathKnight_Control_Undead_Name) and (event == "SPELL_CAST_START") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\ArmyoftheDead_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: RUNE TAP
		if GoHv5_DeathKnight_Data.config.Rune_Tap == "YES" then
			if (GoH_spellID == 48982) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: PLAGUE LEECH
		if GoHv5_DeathKnight_Data.config.Plague_Leech == "YES" then
			if (GoH_spellID == 123693) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: Lichborne
		if GoHv5_DeathKnight_Data.config.Lichborne == "YES" then
			if (GoH_spellID == 49039) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: DESECRATED GROUND
		if GoHv5_DeathKnight_Data.config.Desecrated_Ground == "YES" then
			if (GoH_spellID == 108201) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: VAMPIRIC BLOOD
		if GoHv5_DeathKnight_Data.config.Vampiric_Blood == "YES" then
			if (GoH_spellID == 55233) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Heartbeat.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: RUNE STRIKE
		if GoHv5_DeathKnight_Data.config.Rune_Strike == "YES" then
			if (GoH_spellID == 56815) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Rune_Strike_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: SCOURGE STRIKE
		if GoHv5_DeathKnight_Data.config.Scourge_Strike == "YES" then
			if (GoH_spellID == 55090) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Scourge_Strike_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: DEATH STRIKE
		if GoHv5_DeathKnight_Data.config.Death_Strike == "YES" then
			if (GoH_spellID == 49998) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Heartbeat.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: OBLITERATE
		if GoHv5_DeathKnight_Data.config.Obliterate == "YES" then
			if (GoH_spellID == 49020) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Obliterate_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

end -- END DEATH KNIGHT CLASS CHECK



	-- #######################################################################
	-- #######################################################################
	-- #######################################################################
	-- #######################################################################
	-- #######################################################################
	-- BEGIN RACIALS
	-- #######################################################################

	   -- HUMAN RACIAL: EVERY MAN FOR HIMSELF
	if GoHv5_DeathKnight_Data.config.Every_Man_For_Himself == "YES" then
		if GoH_DeathKnight.Race == "Human" then
			if (GoH_spellID == 59752) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\You_Are_Nothing_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

		-- NIGHTELF RACIAL: -- SHADOWMELD
	if GoHv5_DeathKnight_Data.config.NightElf_Racial_Shadowmeld == "YES" then
		if GoH_DeathKnight.Race == "NightElf" then
			if (GoH_spellID == 58984) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Camouflage.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- WOGEN RACIAL: TWO FORMS
	if GoHv5_DeathKnight_Data.config.Worgen_Two_Forms_Racial == "YES" then
		if GoH_DeathKnight.Race == "Worgen" then
			if (GoH_spellID == 68996) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- GNOME RACIAL: ESCAPE ARTIST
	if GoHv5_DeathKnight_Data.config.Gnome_Escape_Artist_Racial == "YES" then
		if GoH_DeathKnight.Race == "Gnome" then
			if (GoH_spellID == 20589) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- DRAENEI RACIAL: GIFT OF THE NAARU
	if GoHv5_DeathKnight_Data.config.Draenei_Gift_Racial == "YES" then
		if GoH_DeathKnight.Race == "Draenei" then
			if (GoH_spellName == Draenei_Gift_of_the_Naaru_Name) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\HolyPower_1.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- PANDAREN RACIAL: QUAKING PALM
	if GoHv5_DeathKnight_Data.config.Pandaren_Quaking_Palm_Racial == "YES" then
		if GoH_DeathKnight.Race == "Pandaren" then
			if (GoH_spellID == 107079) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Woooaaaoo.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- BLOOD ELF RACIAL: ARCANE TORRENT
	if GoHv5_DeathKnight_Data.config.BloodElf_Arcane_Torrent_Racial == "YES" then
		if (GoH_DeathKnight.Race == "BloodElf") or (GoH_DeathKnight.Race == "Blood Elf") then
			if (GoH_spellName == BloodElf_Arcane_Torrent_Name) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- GOBLIN RACIAL: ROCKET JUMP
	if GoHv5_DeathKnight_Data.config.Goblin_Rocket_Jump_Racial == "YES" then
		if GoH_DeathKnight.Race == "Goblin" then
			if (GoH_spellID == 69070) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- ORC RACIAL: BLOOD FURY
	if GoHv5_DeathKnight_Data.config.Orc_Blood_Fury_Racial == "YES" then
		if GoH_DeathKnight.Race == "Orc" then
			if (GoH_spellName == Orc_Blood_Fury_Name) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- TROLL RACIAL: BERSERKING
	if GoHv5_DeathKnight_Data.config.Troll_Berserking_Racial == "YES" then
		if GoH_DeathKnight.Race == "Troll" then
			if (GoH_spellID == 26297) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- UNDEAD RACIAL: WILL OF THE FORSAKEN
	if GoHv5_DeathKnight_Data.config.Undead_Will_of_the_Forsaken_Racial == "YES" then
		if (GoH_DeathKnight.Race == "Undead") or (GoH_DeathKnight.Race == "Forsaken") or (GoH_DeathKnight.Race == "Scourge") then
			if (GoH_spellID == 7744) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

end



-- #######################################
-- #######################################
-- UNIT SPELLCAST SUCCEEDED
-- #######################################
-- #######################################
function GoH_DeathKnight.events.UNIT_SPELLCAST_SUCCEEDED(caster, GoH_spellName, arg2, arg3, GoH_spellID, arg5, ...)


	-- ################################################################
	-- ################################################################

	-- DEBUGGER
	if GoHv5_DeathKnight_Data.config.DEBUG_UNIT_SPELLCAST_SUCCEEDED == "YES" then
		if (caster == "player") then
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~~~~~~~~~~~ BEGIN DEBUG ~~~~~~~~~~~");
			print("~  (UNIT_SPELLCAST_SUCCEEDED)  ~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
			if caster ~= nil then print("caster: "..caster) end;
			if GoH_spellName ~= nil then print("GoH_spellName: "..GoH_spellName) end;
			if arg2 ~= nil then print("arg2: "..arg2) end;
			if arg3 ~= nil then print("arg3: "..arg3) end;
			if GoH_spellID ~= nil then print("GoH_spellID: "..GoH_spellID) end;
			if arg5 ~= nil then print("arg5: "..arg5) end;
			print("");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~~~~~~~~~~~~ END DEBUG ~~~~~~~~~~~~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
		end
	end

	-- ################################################################
	-- ################################################################


	   -- DWARF RACIAL: STONEFORM
	if GoHv5_DeathKnight_Data.config.Dwarve_Stoneform_Racial == "YES" then
		if GoH_DeathKnight.Race == "Dwarf" then
			if (GoH_spellName == Dwarve_Stoneform_Name) and (caster == "player")then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- TAUREN RACIAL: WAR STOMP
	if GoHv5_DeathKnight_Data.config.Tauren_War_Stomp_Racial == "YES" then
		if GoH_DeathKnight.Race == "Tauren" then
			if (GoH_spellName == Tauren_War_Stomp_Name) and (caster == "player")then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end


	if (GoH_DeathKnight.Class == "DEATHKNIGHT") then -- BEGIN CLASS CHECK

		-- DEATH KNIGHT: ACHERUS DEATHCHARGER
		if GoHv5_DeathKnight_Data.config.Acherus_Deathcharger == "YES" then
			if (GoH_spellName == DeathKnight_Acherus_Deathcharger_Name) and (caster == "player")then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Summon_Mount_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- DO YOUR EMOTE
					if GoHv5_DeathKnight_Data.config.Acherus_Deathcharger_UseName == "YES" then
						if GoH_DeathKnight.Gender == "Female" then
								SendChatMessage("summons " .. GoHv5_DeathKnight_Data.config.Acherus_Deathcharger_CustomName .. ", her trusty " .. GetSpellLink(DeathKnight_Acherus_Deathcharger_ID) .. ".", "EMOTE");
						else
								SendChatMessage("summons " .. GoHv5_DeathKnight_Data.config.Acherus_Deathcharger_CustomName .. ", his trusty " .. GetSpellLink(DeathKnight_Acherus_Deathcharger_ID) .. ".", "EMOTE");
						end
					end

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end

			end
		end

		-- DEATH KNIGHT: WINGED STEED OF THE EBON BLADE
		if GoHv5_DeathKnight_Data.config.Winged_Steed_of_the_Ebon_Blade == "YES" then
			if (GoH_spellName == DeathKnight_Winged_Steed_Name) and (caster == "player")then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Summon_Mount_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- DO YOUR EMOTE
					if GoHv5_DeathKnight_Data.config.Winged_Steed_of_the_Ebon_Blade_UseName == "YES" then
						if GoH_DeathKnight.Gender == "Female" then
								SendChatMessage("summons " .. GoHv5_DeathKnight_Data.config.Winged_Steed_of_the_Ebon_Blade_CustomName .. ", her trusty " .. GetSpellLink(DeathKnight_Winged_Steed_ID) .. ".", "EMOTE");
						else
								SendChatMessage("summons " .. GoHv5_DeathKnight_Data.config.Winged_Steed_of_the_Ebon_Blade_CustomName .. ", his trusty " .. GetSpellLink(DeathKnight_Winged_Steed_ID) .. ".", "EMOTE");
						end
					end

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

	end -- END DEATH KNIGHT CLASS CHECK
end




-- #######################################
-- #######################################
-- PLAYER ENTER COMBAT SOUNDS
-- #######################################
-- #######################################
function GoH_DeathKnight.events.PLAYER_REGEN_DISABLED()

	-- IF YOU HAVE JUST ENTERED COMBAT RESET THE DAMAGE TAKEN VARIABLE AND FLAWLESS VICTORY
	GoHv5_DeathKnight_Data.config.Has_Taken_Damage = "NO";
	GoHv5_DeathKnight_Data.config.Flawless_Victory = "NO";

	if GoHv5_DeathKnight_Data.config.Menu_Fight_Sound == "YES" then

			if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

				-- PLAY YOUR SOUND
				PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Fight_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

				-- RESET THE TIMER
				GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
				-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

			end
	end

		-- #######################################
		-- #######################################

		if GoHv5_DeathKnight_Data.config.Menu_Fight_Music == "YES" then

					-- PLAY FIGHTING MUSIC
						-- CALL RANDOM MATH GENERATOR
						GoH_DeathKnight.NumberRandom = math.random(10);

						-- USE RANDOM MATH GENERATED RESULT

						if (GoH_DeathKnight.NumberRandom == 1) then

							PlayMusic("Interface\\AddOns\\GoH\\Music\\Mortal Kombat beatbox remix by MrWonderspyder.mp3");

						elseif (GoH_DeathKnight.NumberRandom ~= 1) then

							PlayRandomCombatMusic();

						end

		end

		-- #######################################
		-- #######################################

end


-- #######################################
-- #######################################
-- PLAYER LEAVE COMBAT SOUNDS
-- #######################################
-- #######################################
function GoH_DeathKnight.events.PLAYER_REGEN_ENABLED()

	-- IF SOMETHING YOU KILLED IS TEN LEVELS BELOW YOU OR MORE, THEN YOU'RE A LOSER AND ARE INSULTED.
	local Temp_Level = (tonumber(GoH_DeathKnight.CharLevel) - 10);
	-- print(Temp_Level);
	-- print(GoHv5_DeathKnight_Data.config.Last_Kill_By_You_Level);

	if (GoHv5_DeathKnight_Data.config.KnownTypes == "player") and (GoHv5_DeathKnight_Data.config.Target_Level_Temp_Value ~=nil) then
		GoHv5_DeathKnight_Data.config.Last_Kill_By_You_Level = GoHv5_DeathKnight_Data.config.Target_Level_Temp_Value;
	end

	if (GoHv5_DeathKnight_Data.config.Last_Kill_By_You_Level ~= nil) and (Temp_Level ~= nil) and (GoHv5_DeathKnight_Data.config.Your_Target_Was_A ~= nil) and (tonumber(GoHv5_DeathKnight_Data.config.Last_Kill_By_You_Level) <= tonumber(Temp_Level)) then

			-- INSULTS (IF YOU HAVE THEM TURNED ON)
			if (GoHv5_DeathKnight_Data.config.Play_Insults == "YES") and (GoHv5_DeathKnight_Data.config.Last_Kill_By_You == "YES") and (GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted == "NO") then

				if (GoHv5_DeathKnight_Data.config.KnownTypes == "player") or (GoHv5_DeathKnight_Data.config.KnownTypes == "not a creature") then
				-- PLAYER OR NOT A CREATURE BUT AN NPC GUARD

					if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

						-- Player
						if (GoHv5_DeathKnight_Data.config.KnownTypes == "player") then
							-- print("You killed a Player much weaker than you are. You're a loser.");
							Play_Only_Insults();

						end
						-- Not a Creature
						if (GoHv5_DeathKnight_Data.config.KnownTypes == "not a creature") then
							-- print("You killed something much weaker than you are. You're a loser.");
							Play_Only_Insults();

						end

						-- RESET THE TIMER
						GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
						-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

						GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted = "YES";
					end
				else
				-- CREATURE BEAST CRITTER ETC

					if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

						-- Humanoid
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Humanoid") then
							-- print("You killed a Humanoid, you loser.");
							Play_Only_Insults();

						end
						-- Critter
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Critter") then
							-- print("You killed a Critter, you loser.");
							Play_Only_Insults();

						end
						-- Beast
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Beast") then
							-- print("You killed a Beast, you loser.");
							Play_Only_Insults();

						end
						-- Dragonkin
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Dragonkin") then
							-- print("You killed a Dragonkin, you loser.");
							Play_Only_Insults();

						end
						-- Demon
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Demon") then
							-- print("You killed a Demon, you loser.");
							Play_Only_Insults();

						end
						-- Elemental
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Elemental") then
							-- print("You killed an Elemental, you loser.");
							Play_Only_Insults();

						end
						-- Giant
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Giant") then
							-- print("You killed a Giant, you loser.");
							Play_Only_Insults();

						end
						-- Undead
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Undead") then
							-- print("You killed an Undead, you loser.");
							Play_Only_Insults();

						end
						-- Mechanical
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Mechanical") then
							-- print("You killed something Mechanical, you loser.");
							Play_Only_Insults();

						end
						-- Gas Cloud
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Gas Cloud") then
							-- print("You killed a Gas Cloud, you loser.");
							Play_Only_Insults();

						end
						-- Totem
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Totem") then
							-- print("You killed a Totem, you loser.");
							-- Play_Only_Insults();

						end
						-- Non-combat Pet
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Non-combat Pet") then
							-- print("You killed a Non-combat Pet, you loser.");
							-- Play_Only_Insults();

						end
						-- Wild Pet (MOP)
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Wild Pet") then
							-- print("You Beast a Wild Pet, you loser.");
							Play_Only_Insults();

						end
						-- Not specified
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Not specified") then
							-- print("What you killed was Not specified, you loser.");
							Play_Only_Insults();

						end

						-- RESET THE TIMER
						GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
						-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

						GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted = "YES";
					end
				end
			end

	else

		if GoHv5_DeathKnight_Data.config.Flawless_Victory == "NO" then
		-- NOT A FLAWLESS VICTORY BUT YOU STILL KILLED SOMETHING WORTHY

			-- FATALITY (IF YOU HAVE IT TURNED ON)
			if (GoHv5_DeathKnight_Data.config.Menu_Fatality_Sound == "YES") and (GoHv5_DeathKnight_Data.config.Last_Kill_By_You == "YES") then
				if (GoHv5_DeathKnight_Data.config.KnownTypes ~= nil) and ((GoHv5_DeathKnight_Data.config.KnownTypes == "player") or (GoHv5_DeathKnight_Data.config.KnownTypes == "not a creature")) then
				-- PLAYER OR NOT A CREATURE BUT AN NPC GUARD

					if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

						-- Player
						if (GoHv5_DeathKnight_Data.config.KnownTypes == "player") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Fatality_Praises();

						end
						-- Not a Creature
						if (GoHv5_DeathKnight_Data.config.KnownTypes == "not a creature") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Fatality_Praises();

						end

						-- RESET THE TIMER
						GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
						-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

						GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted = "YES";
					end
				else
				-- CREATURE BEAST CRITTER ETC

					if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

						-- Humanoid
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Humanoid") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Fatality_Praises();

						end
						-- Critter
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Critter") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Babality_Fatality_Praises();

						end
						-- Beast
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Beast") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Animality_Fatality_Praises();

						end
						-- Dragonkin
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Dragonkin") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Animality_Fatality_Praises();

						end
						-- Demon
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Demon") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Fatality_Praises();

						end
						-- Elemental
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Elemental") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Fatality_Praises();

						end
						-- Giant
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Giant") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Fatality_Praises();

						end
						-- Undead
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Undead") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Fatality_Praises();

						end
						-- Mechanical
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Mechanical") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Fatality_Praises();

						end
						-- Gas Cloud
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Gas Cloud") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Fatality_Praises();

						end
						-- Totem
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Totem") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							-- Play_Fatality_Praises();

						end
						-- Non-combat Pet
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Non-combat Pet") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							-- Play_Babality_Fatality_Praises();

						end
						-- Wild Pet (MOP)
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Wild Pet") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Animality_Fatality_Praises();

						end
						-- Not specified
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Not specified") then

							-- WELL DONE, FATALITY! - PLAY YOUR SOUND
							Play_Fatality_Praises();

						end

						-- RESET THE TIMER
						GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
						-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

					end
				end
			end

		else
		-- A FLAWLESS VICTORY - YOU SHOULD BE PROUD!
		-- RESET THE VARIABLE TO 'NO'.
		GoHv5_DeathKnight_Data.config.Flawless_Victory = "NO";

			-- FATALITY (IF YOU HAVE IT TURNED ON ALSO ENABLES THE FLAWLESS VICTORY)
			if (GoHv5_DeathKnight_Data.config.Menu_Fatality_Sound == "YES") and (GoHv5_DeathKnight_Data.config.Last_Kill_By_You == "YES") then
				if (GoHv5_DeathKnight_Data.config.KnownTypes ~= nil) and ((GoHv5_DeathKnight_Data.config.KnownTypes == "player") or (GoHv5_DeathKnight_Data.config.KnownTypes == "not a creature")) then
				-- PLAYER OR NOT A CREATURE BUT AN NPC GUARD OF OR NEAR YOUR LEVEL

					if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

						-- Player
						if (GoHv5_DeathKnight_Data.config.KnownTypes == "player") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end
						-- Not a Creature
						if (GoHv5_DeathKnight_Data.config.KnownTypes == "not a creature") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end

						-- RESET THE TIMER
						GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
						-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

						GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted = "YES";
					end
				else
				-- CREATURE BEAST CRITTER ETC OF OR NEAR YOUR LEVEL

					if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

						-- Humanoid
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Humanoid") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end
						-- Critter
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Critter") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end
						-- Beast
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Beast") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end
						-- Dragonkin
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Dragonkin") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end
						-- Demon
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Demon") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end
						-- Elemental
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Elemental") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end
						-- Giant
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Giant") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end
						-- Undead
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Undead") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end
						-- Mechanical
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Mechanical") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end
						-- Gas Cloud
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Gas Cloud") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end
						-- Totem
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Totem") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							-- Play_Flawless_Victory();

						end
						-- Non-combat Pet
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Non-combat Pet") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							-- Play_Flawless_Victory();

						end
						-- Wild Pet (MOP)
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Wild Pet") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end
						-- Not specified
						if (GoHv5_DeathKnight_Data.config.Your_Target_Was_A == "Not specified") then

							-- FLAWLESS VICTORY! - PLAY YOUR SOUND
							Play_Flawless_Victory();

						end

						-- RESET THE TIMER
						GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
						-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

					end
				end
			end

		end
	end


		-- #######################################
		-- #######################################

		if GoHv5_DeathKnight_Data.config.Menu_Fight_Music == "YES" then

			-- STOP FIGHTING MUSIC
				StopMusic();
		end

		-- #######################################
		-- #######################################


		-- GOH SETTING: RESET LAST KILL BY YOU
		GoHv5_DeathKnight_Data.config.Last_Kill_By_You = "NO";

		-- GOH SETTING: RESET YOU HAVE BEEN INSULTED
		GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted = "NO";
end


function GoH_DeathKnight.events.PLAYER_LOGIN()

			local playerClass, EngClass = UnitClass("player");
			GoH_DeathKnight.Class = EngClass;
			GoHv5_DeathKnight_Data.config.LoggedInAsClass = GoH_DeathKnight.Class;
			-- print(GoHv5_DeathKnight_Data.config.LoggedInAsClass)

			-- JUST LOGGED IN SO RESET DAMAGE TAKEN VARIABLE AND FLAWLESS VICTORY
			GoHv5_DeathKnight_Data.config.Has_Taken_Damage = "NO";
			GoHv5_DeathKnight_Data.config.Flawless_Victory = "NO";

			if (GoH_DeathKnight.Class == "DEATHKNIGHT") then
				if GoHv5_DeathKnight_Data.config.Stupid_Login_Sound == "YES"then

					if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

						-- PLAY YOUR SOUND
						-- REMEMBER WHO OWNS YOUR SOUL DEATHKNIGHT
						if (GoH_DeathKnight.Gender == "Female") then
							PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Female_WoW_Sounds\\Remember_Who_Owns_Your_Soul_DeathKnight_Female.mp3","Master");
						else
							PlaySoundFile("Sound\\Creature\\LichKing\\EH_LichKing_Irritated1.wav","Master");
						end

						-- RESET THE TIMER
						GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
						-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

					end
				end
			end
end


function do_HornOfWinter_Reminder()

		if GoHv5_DeathKnight_Data.config.Horn_of_Winter_Ends == "YES" then -- BEGIN HoW Ended CHECK
			if GoHv5_DeathKnight_Data.config.Horn_of_Winter_Casted == "YES" then -- BEGIN HoW Casted
				if (GoH_DeathKnight.Class == "DEATHKNIGHT") then -- BEGIN CLASS CHECK

					if UnitAura("player", DeathKnight_Horn_of_Winter_Name) then -- BEGIN AURA CHECK
						-- DO NOTHING AS HORN OF WINTER IS STILL PRESENT.

					else -- ELSE AURA CHECK

						-- SET HORN OF WINTER CAST TRACKER BACK TO NO.
						GoHv5_DeathKnight_Data.config.Horn_of_Winter_Casted = "NO";

						-- IF HORN OF WINTER IS NOT PRESENT, THEN REMINDER YOU!
						PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\HornOfWinter_Ends_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

						-- DISPLAY AN ERROR FRAME MESSAGE TOO.
						UIErrorsFrame:AddMessage(DeathKnight_Horn_of_Winter_Name .. " is no longer active.", 1, 1, 0);

					end -- END AURA CHECK
				end -- END CLASS CHECK
			end -- END HoW Casted
		end -- END HoW Ended CHECK

end
